﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.IO.Pipes;
using System.Security.Principal;
using System.Net.Sockets;
using System.Net;

namespace TestCLI
{
    public partial class Form1 : Form
    {
        private Process _program;
        private StreamWriter _programInput;

        private delegate void SafeCallDlg(string data);

        public Form1()
        {
            InitializeComponent();
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            openFile.Filter = "exe files (*.exe)|*.exe|bat files (*.bat)|*.bat|All files (*.*)|*.*";


            if (openFile.ShowDialog() == DialogResult.OK)
            {
                txtApp.Text = openFile.FileName;
            }
        }

        private void btnRun_Click(object sender, EventArgs e)
        {
            //Check if program is running, if yes, force kill
            if(_program != null)
            {
                if( !_program.HasExited)
                {
                    _program.Kill();
                }
                else
                {
                    _program.Dispose();
                    _program = null;
                }   
            }

            //Initialize process
            FileInfo fiProgram = new FileInfo(txtApp.Text);

            _program = new Process();
            _program.StartInfo.FileName = fiProgram.FullName;
            _program.StartInfo.WorkingDirectory = fiProgram.Directory.FullName;
            _program.StartInfo.Arguments = "/host=127.0.0.1 /port=7755";
            _program.StartInfo.UseShellExecute = false;
            _program.StartInfo.RedirectStandardOutput = true;
            _program.StartInfo.RedirectStandardInput = true;
            _program.StartInfo.RedirectStandardError = true;
            _program.StartInfo.CreateNoWindow = true;
            _program.EnableRaisingEvents = true;

            //Attach events
            _program.OutputDataReceived += FuncInputDataReceived;


            //Go
            _program.Start();
            _program.BeginOutputReadLine();
            _programInput = _program.StandardInput;
        }

        public void FuncInputDataReceived(object sender, DataReceivedEventArgs e)
        {
            if(e.Data == null)
            {
                return;
            }

            WriteTextSafe(e.Data);

        }
        private void WriteTextSafe(string data)
        {
            if(txtOut.InvokeRequired)
            {
                txtOut.Invoke(new SafeCallDlg(WriteTextUnSafe), new object[] { data });
            }
            else
            {
                WriteTextUnSafe(data);
            }
        }

        private void WriteTextUnSafe(string data)
        {
            txtIn.AppendText("\r\n" + data);
        }

        private void txtOut_KeyPress(object sender, KeyPressEventArgs e)
        {
            if(e.KeyChar == (char)Keys.Enter)
            {
              // This constructor arbitrarily assigns the local port number.
              UdpClient udpClient = new UdpClient();
              try
              {
                udpClient.Connect("127.0.0.1", 7755);

                // Sends a message to the host to which you have connected.
                Byte[] sendBytes = Encoding.ASCII.GetBytes(txtOut.Lines[txtOut.Lines.Length - 1]);

                udpClient.Send(sendBytes, sendBytes.Length);

                IPEndPoint RemoteIpEndPoint = new IPEndPoint(IPAddress.Any, 0);

                udpClient.Close();
              }
              catch (Exception eee)
              {
                Console.WriteLine(eee.ToString());
              }
            }
        }
    }
}
